/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.12 Revision 1.111
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/mysql.eclass,v 1.12 2006/01/31 19:47:50 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/mysql.eclass,v 1.111 2009/07/06 18:21:18 robbat2 Exp $
4 4
5# Author: Francesco Riosa <vivo at gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: Francesco Riosa <vivo at gentoo.org> 6# Maintainer: MySQL Team <mysql-bugs@gentoo.org>
7# - Luca Longinotti <chtekk@gentoo.org>
8# - Robin H. Johnson <robbat2@gentoo.org>
7 9
10WANT_AUTOCONF="latest"
11WANT_AUTOMAKE="latest"
12
8inherit eutils flag-o-matic gnuconfig mysql_fx 13inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator
9 14
10#major, minor only in the slot
11SLOT=$(( ${MYSQL_VERSION_ID} / 10000 ))
12
13# shorten the path because the socket path length must be shorter than 107 chars 15# Shorten the path because the socket path length must be shorter than 107 chars
14# and we will run a mysql server during test phase 16# and we will run a mysql server during test phase
15S="${WORKDIR}/${PN}" 17S="${WORKDIR}/mysql"
16 18
19[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
20if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
21 EGIT_PROJECT=mysql-extras
22 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
23 inherit git
24fi
25
26# MYSQL_VERSION_ID will be:
27# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
28# This is an important part, because many of the choices the MySQL ebuild will do
29# depend on this variable.
30# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
31# We also strip off upstream's trailing letter that they use to respin tarballs
32
33MYSQL_VERSION_ID=""
34tpv="${PV%[a-z]}"
35tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
36for vatom in 0 1 2 3 ; do
37 # pad to length 2
38 tpv[${vatom}]="00${tpv[${vatom}]}"
39 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
40done
41# strip leading "0" (otherwise it's considered an octal number by BASH)
42MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
43
44# Community features are available in mysql-community
45# AND in the re-merged mysql-5.0.82 and newer
46if [ "${PN}" == "mysql-community" ]; then
47 MYSQL_COMMUNITY_FEATURES=1
48elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
49 MYSQL_COMMUNITY_FEATURES=1
50else
51 MYSQL_COMMUNITY_FEATURES=0
52fi
53
54# Be warned, *DEPEND are version-dependant
55# These are used for both runtime and compiletime
56DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
57 userland_GNU? ( sys-process/procps )
58 >=sys-apps/sed-4
59 >=sys-apps/texinfo-4.7-r1
60 >=sys-libs/readline-4.1
61 >=sys-libs/zlib-1.2.3"
62
63# Having different flavours at the same time is not a good idea
64for i in "" "-community" ; do
65 [[ "${i}" == ${PN#mysql} ]] ||
66 DEPEND="${DEPEND} !dev-db/mysql${i}"
67done
68
69RDEPEND="${DEPEND}
70 !minimal? ( dev-db/mysql-init-scripts )
71 selinux? ( sec-policy/selinux-mysql )"
72
73# compile-time-only
74mysql_version_is_at_least "5.1" \
75|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
76
77# compile-time-only
78mysql_version_is_at_least "5.1.12" \
79&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
80
81# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
82PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
83
84# For other stuff to bring us in
85PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})"
86
87# Work out the default SERVER_URI correctly
88if [ -z "${SERVER_URI}" ]; then
89 # The community build is on the mirrors
90 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
91 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
92 # The (old) enterprise source is on the primary site only
93 elif [ "${PN}" == "mysql" ]; then
94 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
95 fi
96fi
97
98# Define correct SRC_URIs
99SRC_URI="${SERVER_URI}"
100
101[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI}
102 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
103 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
104mysql_version_is_at_least "5.1.12" \
105&& [[ -n "${PBXT_VERSION}" ]] \
106&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
107
17DESCRIPTION="A fast, multi-threaded, multi-user SQL database server" 108DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
18HOMEPAGE="http://www.mysql.com/" 109HOMEPAGE="http://www.mysql.com/"
19NEWP="${P/_/-}"
20SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${NEWP}.tar.gz
21 mirror://gentoo/mysql-extras-20060115.tar.bz2"
22LICENSE="GPL-2" 110LICENSE="GPL-2"
111SLOT="0"
23IUSE="big-tables berkdb debug minimal perl selinux srvdir ssl static" 112IUSE="big-tables debug embedded minimal perl selinux ssl static"
24RESTRICT="primaryuri confcache"
25DEPEND="app-admin/eselect-mysql"
26 113
114mysql_version_is_at_least "4.1" \
115&& IUSE="${IUSE} latin1"
116
27mysql_version_is_at_least "4.01.03.00" \ 117mysql_version_is_at_least "4.1.3" \
28&& IUSE="${IUSE} cluster extraengine" 118&& IUSE="${IUSE} cluster extraengine"
29 119
120mysql_version_is_at_least "5.0" \
121|| IUSE="${IUSE} raid"
122
30mysql_version_is_at_least "5.00.18.00" \ 123mysql_version_is_at_least "5.0.18" \
31&& IUSE="${IUSE} max-idx-128" 124&& IUSE="${IUSE} max-idx-128"
32 125
33mysql_version_is_at_least "5.01.00.00" \ 126mysql_version_is_at_least "5.1" \
127|| IUSE="${IUSE} berkdb"
128
129mysql_version_is_at_least "5.1.12" \
34&& IUSE="${IUSE} innodb" 130&& IUSE="${IUSE} pbxt"
35 131
132[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
133&& IUSE="${IUSE} community profiling"
134
36EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_config pkg_postrm 135EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
136 pkg_postinst pkg_config pkg_postrm
137
138#
139# HELPER FUNCTIONS:
140#
141
142mysql_disable_test() {
143 local testname="${1}" ; shift
144 local reason="${@}"
145 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
146 echo ${testname} : ${reason} >> "${mysql_disable_file}"
147 ewarn "test '${testname}' disabled: '${reason}'"
148}
37 149
38# void mysql_init_vars() 150# void mysql_init_vars()
39# 151#
40# initialize global variables 152# Initialize global variables
41# 2005-11-19 <vivo at gentoo.org> 153# 2005-11-19 <vivo@gentoo.org>
154
42mysql_init_vars() { 155mysql_init_vars() {
43
44 if [[ ${SLOT} -eq 0 ]] ; then
45 MY_SUFFIX=""
46 else
47 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
48 fi
49 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"} 156 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
50 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"} 157 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
51 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"} 158 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
52 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"} 159 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
53 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"} 160 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
54 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"} 161 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
55 162
56 if [ -z "${DATADIR}" ]; then 163 if [[ -z "${MY_DATADIR}" ]] ; then
57 DATADIR="" 164 MY_DATADIR=""
58 if [ -f "${SYSCONFDIR}/my.cnf" ] ; then 165 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
59 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null | sed -ne '/datadir/s|^--datadir=||p' | tail -n1` 166 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
167 | sed -ne '/datadir/s|^--datadir=||p' \
168 | tail -n1`
60 if [ -z "${DATADIR}" ]; then 169 if [[ -z "${MY_DATADIR}" ]] ; then
61 if useq "srvdir" ; then
62 DATADIR="/srv/localhost/mysql/datadir"
63 else
64 DATADIR=`grep ^datadir "${SYSCONFDIR}/my.cnf" | sed -e 's/.*=\s*//'` 170 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
65 fi 171 | sed -e 's/.*=\s*//' \
172 | tail -n1`
66 fi 173 fi
67 fi 174 fi
68 if [ -z "${DATADIR}" ]; then 175 if [[ -z "${MY_DATADIR}" ]] ; then
69 DATADIR="${MY_LOCALSTATEDIR}" 176 MY_DATADIR="${MY_LOCALSTATEDIR}"
70 einfo "Using default DATADIR" 177 einfo "Using default MY_DATADIR"
71 fi 178 fi
72 einfo "MySQL DATADIR is ${DATADIR}" 179 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
73 180
74 if [ -z "${PREVIOUS_DATADIR}" ] ; then 181 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
75 if [ -a "${DATADIR}" ] ; then 182 if [[ -e "${MY_DATADIR}" ]] ; then
76 ewarn "Previous datadir found, it's YOUR job to change" 183 # If you get this and you're wondering about it, see bug #207636
77 ewarn "ownership and have care of it" 184 elog "MySQL datadir found in ${MY_DATADIR}"
185 elog "A new one will not be created."
78 PREVIOUS_DATADIR="yes" 186 PREVIOUS_DATADIR="yes"
79 export PREVIOUS_DATADIR
80 else 187 else
81 PREVIOUS_DATADIR="no" 188 PREVIOUS_DATADIR="no"
82 export PREVIOUS_DATADIR
83 fi 189 fi
190 export PREVIOUS_DATADIR
191 fi
192 else
193 if [[ ${EBUILD_PHASE} == "config" ]]; then
194 local new_MY_DATADIR
195 new_MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
196 | sed -ne '/datadir/s|^--datadir=||p' \
197 | tail -n1`
198
199 if [[ ( -n "${new_MY_DATADIR}" ) && ( "${new_MY_DATADIR}" != "${MY_DATADIR}" ) ]]; then
200 ewarn "MySQL MY_DATADIR has changed"
201 ewarn "from ${MY_DATADIR}"
202 ewarn "to ${new_MY_DATADIR}"
203 MY_DATADIR="${new_MY_DATADIR}"
84 fi 204 fi
85 fi 205 fi
206 fi
86 207
208 MY_SOURCEDIR=${SERVER_URI##*/}
209 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
210
87 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR 211 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
88 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 212 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
89 export MY_INCLUDEDIR 213 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
90 export DATADIR
91} 214}
92 215
216configure_minimal() {
217 # These are things we exclude from a minimal build, please
218 # note that the server actually does get built and installed,
219 # but we then delete it before packaging.
220 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
221
222 for i in ${minimal_exclude_list} ; do
223 myconf="${myconf} --without-${i}"
224 done
225 myconf="${myconf} --with-extra-charsets=none"
226 myconf="${myconf} --enable-local-infile"
227
228 if use static ; then
229 myconf="${myconf} --with-client-ldflags=-all-static"
230 myconf="${myconf} --disable-shared --with-pic"
231 else
232 myconf="${myconf} --enable-shared --enable-static"
233 fi
234
235 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
236 myconf="${myconf} --with-charset=utf8"
237 myconf="${myconf} --with-collation=utf8_general_ci"
238 else
239 myconf="${myconf} --with-charset=latin1"
240 myconf="${myconf} --with-collation=latin1_swedish_ci"
241 fi
242}
243
244configure_common() {
245 myconf="${myconf} $(use_with big-tables)"
246 myconf="${myconf} --enable-local-infile"
247 myconf="${myconf} --with-extra-charsets=all"
248 myconf="${myconf} --with-mysqld-user=mysql"
249 myconf="${myconf} --with-server"
250 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
251 myconf="${myconf} --without-libwrap"
252
253 if use static ; then
254 myconf="${myconf} --with-mysqld-ldflags=-all-static"
255 myconf="${myconf} --with-client-ldflags=-all-static"
256 myconf="${myconf} --disable-shared --with-pic"
257 else
258 myconf="${myconf} --enable-shared --enable-static"
259 fi
260
261 if use debug ; then
262 myconf="${myconf} --with-debug=full"
263 else
264 myconf="${myconf} --without-debug"
265 mysql_version_is_at_least "4.1.3" \
266 && use cluster \
267 && myconf="${myconf} --without-ndb-debug"
268 fi
269
270 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
271 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
272 ewarn "and a collation of ${MYSQL_DEFAULT_COLLATION}."
273 ewarn "You MUST file bugs without these variables set."
274 myconf="${myconf} --with-charset=${MYSQL_DEFAULT_CHARSET}"
275 myconf="${myconf} --with-collation=${MYSQL_DEFAULT_COLLATION}"
276 elif mysql_version_is_at_least "4.1" && ! use latin1 ; then
277 myconf="${myconf} --with-charset=utf8"
278 myconf="${myconf} --with-collation=utf8_general_ci"
279 else
280 myconf="${myconf} --with-charset=latin1"
281 myconf="${myconf} --with-collation=latin1_swedish_ci"
282 fi
283
284 if use embedded ; then
285 myconf="${myconf} --with-embedded-privilege-control"
286 myconf="${myconf} --with-embedded-server"
287 else
288 myconf="${myconf} --without-embedded-privilege-control"
289 myconf="${myconf} --without-embedded-server"
290 fi
291
292}
293
294configure_40_41_50() {
295 myconf="${myconf} $(use_with perl bench)"
296 myconf="${myconf} --enable-assembler"
297 myconf="${myconf} --with-extra-tools"
298 myconf="${myconf} --with-innodb"
299 myconf="${myconf} --without-readline"
300 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
301
302 # --with-vio is not needed anymore, it's on by default and
303 # has been removed from configure
304 if use ssl ; then
305 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
306 fi
307
308 if mysql_version_is_at_least "5.1.11" ; then
309 myconf="${myconf} $(use_with ssl)"
310 else
311 myconf="${myconf} $(use_with ssl openssl)"
312 fi
313
314 if mysql_version_is_at_least "5.0.60" ; then
315 if use berkdb ; then
316 elog "Berkeley DB support was disabled due to build failures"
317 elog "on multiple arches, go to a version earlier than 5.0.60"
318 elog "if you want it again. Gentoo bug #224067."
319 fi
320 myconf="${myconf} --without-berkeley-db"
321 elif use berkdb ; then
322 # The following fix is due to a bug with bdb on SPARC's. See:
323 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
324 # It comes down to non-64-bit safety problems.
325 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
326 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
327 myconf="${myconf} --without-berkeley-db"
328 else
329 myconf="${myconf} --with-berkeley-db=./bdb"
330 fi
331 else
332 myconf="${myconf} --without-berkeley-db"
333 fi
334
335 if mysql_version_is_at_least "4.1.3" ; then
336 myconf="${myconf} --with-geometry"
337 myconf="${myconf} $(use_with cluster ndbcluster)"
338 fi
339
340 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
341 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
342 myconf="${myconf} --with-archive-storage-engine"
343
344 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
345 myconf="${myconf} --with-csv-storage-engine"
346
347 # http://dev.mysql.com/doc/mysql/en/blackhole-storage-engine.html
348 myconf="${myconf} --with-blackhole-storage-engine"
349
350 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
351 # http://dev.mysql.com/doc/mysql/en/federated-description.html
352 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
353 if mysql_version_is_at_least "5.0.3" ; then
354 elog "Before using the Federated storage engine, please be sure to read"
355 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
356 myconf="${myconf} --with-federated-storage-engine"
357 fi
358 fi
359
360 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
361 myconf="${myconf} `use_enable community community-features`"
362 if use community; then
363 myconf="${myconf} `use_enable profiling`"
364 else
365 myconf="${myconf} --disable-profiling"
366 fi
367 fi
368
369 mysql_version_is_at_least "5.0.18" \
370 && use max-idx-128 \
371 && myconf="${myconf} --with-max-indexes=128"
372}
373
374configure_51() {
375 # TODO: !!!! readd --without-readline
376 # the failure depend upon config/ac-macros/readline.m4 checking into
377 # readline.h instead of history.h
378 myconf="${myconf} $(use_with ssl)"
379 myconf="${myconf} --enable-assembler"
380 myconf="${myconf} --with-geometry"
381 myconf="${myconf} --with-readline"
382 myconf="${myconf} --with-row-based-replication"
383 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
384 myconf="${myconf} --without-pstack"
385 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
386
387 # 5.1 introduces a new way to manage storage engines (plugins)
388 # like configuration=none
389 local plugins="csv,myisam,myisammrg,heap"
390 if use extraengine ; then
391 # like configuration=max-no-ndb, archive and example removed in 5.1.11
392 plugins="${plugins},archive,blackhole,example,federated,partition"
393
394 elog "Before using the Federated storage engine, please be sure to read"
395 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
396 fi
397
398 # Upstream specifically requests that InnoDB always be built.
399 plugins="${plugins},innobase"
400
401 # like configuration=max-no-ndb
402 if use cluster ; then
403 plugins="${plugins},ndbcluster"
404 myconf="${myconf} --with-ndb-binlog"
405 fi
406
407 if mysql_version_is_at_least "5.2" ; then
408 plugins="${plugins},falcon"
409 fi
410
411 myconf="${myconf} --with-plugins=${plugins}"
412}
413
414pbxt_src_compile() {
415 mysql_init_vars
416
417 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
418
419 einfo "Reconfiguring dir '${PWD}'"
420 AT_GNUCONF_UPDATE="yes" eautoreconf
421
422 local myconf=""
423 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}"
424 use debug && myconf="${myconf} --with-debug=full"
425 # TODO: is it safe/needed to use econf here ?
426 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
427 # TODO: is it safe/needed to use emake here ?
428 make || die "Problem making PBXT storage engine (${myconf})"
429
430 popd
431 # TODO: modify test suite for PBXT
432}
433
434pbxt_src_install() {
435 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
436 make install || die "Failed to install PBXT"
437 popd
438}
439
440#
441# EBUILD FUNCTIONS
442#
93mysql_pkg_setup() { 443mysql_pkg_setup() {
444 if hasq test ${FEATURES} ; then
445 if ! use minimal ; then
446 if [[ $UID -eq 0 ]]; then
447 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
448 fi
449 fi
450 fi
94 451
452 # Check for USE flag problems in pkg_setup
453 if use static && use ssl ; then
454 eerror "MySQL does not support being built statically with SSL support enabled!"
455 die "MySQL does not support being built statically with SSL support enabled!"
456 fi
457
458 if ! mysql_version_is_at_least "5.0" \
459 && use raid \
460 && use static ; then
461 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
462 eerror "with RAID support enabled."
463 die "USE flags 'raid' and 'static' conflict!"
464 fi
465
466 if mysql_version_is_at_least "4.1.3" \
467 && ( use cluster || use extraengine ) \
468 && use minimal ; then
469 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
470 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
471 fi
472
473 # This should come after all of the die statements
95 enewgroup mysql 60 || die "problem adding group mysql" 474 enewgroup mysql 60 || die "problem adding 'mysql' group"
96 enewuser mysql 60 -1 /dev/null mysql \ 475 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
97 || die "problem adding user mysql" 476
477 mysql_check_version_range "4.0 to 5.0.99.99" \
478 && use berkdb \
479 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
98} 480}
99 481
100mysql_src_unpack() { 482mysql_src_unpack() {
101 483 # Initialize the proper variables first
102 mysql_init_vars 484 mysql_init_vars
103 485
104 if useq static && useq ssl; then
105 local msg="MySQL does not support building statically with SSL support"
106 eerror "${msg}"
107 die "${msg}"
108 fi
109
110 if mysql_version_is_at_least "4.01.03.00" \
111 && useq cluster \
112 || useq extraengine \
113 && useq minimal ; then
114 die "USEs cluster, extraengine conflicts with \"minimal\""
115 fi
116
117 unpack ${A} || die 486 unpack ${A}
118 487 # Grab the patches
488 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
489
119 mv -f "${WORKDIR}/${NEWP}" "${S}" 490 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
120 cd "${S}" 491 cd "${S}"
121 492
493 # Apply the patches for this MySQL version
122 EPATCH_SUFFIX="patch" 494 EPATCH_SUFFIX="patch"
123 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 495 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
496 # Clean out old items
497 rm -f "${EPATCH_SOURCE}"/*
498 # Now link in right patches
124 mysql_mv_patches 499 mysql_mv_patches
125 epatch || die "failed to apply all patches" 500 # And apply
501 epatch
126 502
127 # additional check, remove bundled zlib 503 # Additional checks, remove bundled zlib
128 rm -f "${S}/zlib/"*.[ch] 504 rm -f "${S}/zlib/"*.[ch]
129 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 505 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
130 rm -f scripts/mysqlbug 506 rm -f "scripts/mysqlbug"
131
132 # Multilib issue with zlib detection
133 mysql_version_is_at_least "5.00.15.00" \
134 && sed -i -e "s:zlib_dir/lib:zlib_dir/$(get_libdir):g" \
135 "${S}/config/ac-macros/zlib.m4"
136 507
137 # Make charsets install in the right place 508 # Make charsets install in the right place
138 find . -name 'Makefile.am' \ 509 find . -name 'Makefile.am' \
139 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 510 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
140 511
141 # Manage mysqlmanager
142 mysql_version_is_at_least "5.00.15.00" \ 512 if mysql_version_is_at_least "4.1" ; then
143 && sed -i -e "s!@GENTOO_EXT@!${MY_SUFFIX}!g" \
144 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \
145 "${S}/server-tools/instance-manager/Makefile.am"
146
147 # remove what need to be recreated, so we are sure it's actually done 513 # Remove what needs to be recreated, so we're sure it's actually done
148 find . -name Makefile -o -name Makefile.in -o -name configure -exec rm -f {} \; 514 find . -name Makefile \
515 -o -name Makefile.in \
516 -o -name configure \
517 -exec rm -f {} \;
149 rm ltmain.sh 518 rm -f "ltmain.sh"
519 rm -f "scripts/mysqlbug"
520 fi
150 521
151 local rebuilddirlist d buildstep bdbdir 522 local rebuilddirlist d
152 523
153 if mysql_version_is_at_least "5.01.00.00" ; then 524 if mysql_version_is_at_least "5.1.12" ; then
154 rebuilddirlist=". storage/innobase" 525 rebuilddirlist="."
155 bdbdir='storage/bdb/dist' 526 # TODO: check this with a cmake expert
527 cmake \
528 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
529 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
530 "storage/innobase"
156 else 531 else
157 rebuilddirlist=". innobase" 532 rebuilddirlist=". innobase"
158 bdbdir='bdb/dist'
159 fi 533 fi
160 534
161 for d in ${rebuilddirlist}; do 535 for d in ${rebuilddirlist} ; do
162 einfo "reconfiguring dir \"${d}\"" 536 einfo "Reconfiguring dir '${d}'"
163 pushd "${d}" &>/dev/null 537 pushd "${d}" &>/dev/null
164 for buildstep in \ 538 AT_GNUCONF_UPDATE="yes" eautoreconf
165 'libtoolize --copy --force' \
166 'aclocal --force' \
167 'autoheader --force -Wnone' \
168 'autoconf --force -Wnone' \
169 'automake --force --force-missing -Wnone' \
170 'gnuconfig_update'
171 do
172 einfo "performing ${buildstep}"
173 ${buildstep} || die "failed ${buildstep/ */} dir \"${d}\""
174 done
175 popd &>/dev/null 539 popd &>/dev/null
176 done 540 done
177 541
178 if useq berkdb && ! mysql_check_version_range "5.01.00.00 to 5.01.06.99" 542 if mysql_check_version_range "4.1 to 5.0.99.99" \
179 then 543 && use berkdb ; then
180 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f ltmain.sh "${bdbdir}/ltmain.sh" 544 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
181 pushd "${bdbdir}" && sh s_all || die "failed bdb reconfigure" &>/dev/null 545 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
546 || die "Could not copy libtool.m4 to bdb/dist/"
547 #These files exist only with libtool-2*, and need to be included.
548 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then
549 cat "/usr/share/aclocal/ltsugar.m4" >> "bdb/dist/aclocal/libtool.ac"
550 cat "/usr/share/aclocal/ltversion.m4" >> "bdb/dist/aclocal/libtool.ac"
551 cat "/usr/share/aclocal/lt~obsolete.m4" >> "bdb/dist/aclocal/libtool.ac"
552 cat "/usr/share/aclocal/ltoptions.m4" >> "bdb/dist/aclocal/libtool.ac"
553 fi
554 pushd "bdb/dist" &>/dev/null
555 sh s_all \
556 || die "Failed bdb reconfigure"
182 popd &>/dev/null 557 popd &>/dev/null
183 fi 558 fi
184
185} 559}
186 560
187mysql_src_compile() { 561mysql_src_compile() {
188 562 # Make sure the vars are correctly initialized
189 mysql_init_vars 563 mysql_init_vars
564
565 # $myconf is modified by the configure_* functions
190 local myconf 566 local myconf=""
191 567
192 if useq static ; then 568 if use minimal ; then
193 myconf="${myconf} --with-mysqld-ldflags=-all-static" 569 configure_minimal
194 myconf="${myconf} --with-client-ldflags=-all-static"
195 myconf="${myconf} --disable-shared"
196 else 570 else
197 myconf="${myconf} --enable-shared --enable-static" 571 configure_common
198 fi
199
200 #myconf="${myconf} `use_with tcpd libwrap`"
201 myconf="${myconf} --without-libwrap"
202
203 if useq ssl ; then
204 # --with-vio is not needed anymore, it's on by default and
205 # has been removed from configure
206 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio"
207 if mysql_version_is_at_least "5.00.06.00" ; then 572 if mysql_version_is_at_least "5.1.10" ; then
208 # yassl-0.96 is young break with gcc-4.0 || amd64 573 configure_51
209 #myconf="${myconf} --with-yassl"
210 myconf="${myconf} --with-openssl"
211 else 574 else
212 myconf="${myconf} --with-openssl" 575 configure_40_41_50
213 fi
214 else
215 myconf="${myconf} --without-openssl"
216 fi
217
218 if useq debug; then
219 myconf="${myconf} --with-debug=full"
220 else
221 myconf="${myconf} --without-debug"
222 mysql_version_is_at_least "4.01.03.00" && useq cluster && myconf="${myconf} --without-ndb-debug"
223 fi
224
225 # benchmarking stuff needs perl
226 # and shouldn't be bothered with on minimal builds
227 if useq perl && ! useq minimal; then
228 myconf="${myconf} --with-bench"
229 else
230 myconf="${myconf} --without-bench"
231 fi
232
233 # these are things we exclude from a minimal build
234 # note that the server actually does get built and installed
235 # but we then delete it before packaging.
236 local minimal_exclude_list="server embedded-server extra-tools innodb"
237 if ! useq minimal; then
238 for i in ${minimal_exclude_list}; do
239 myconf="${myconf} --with-${i}"
240 done
241
242 if useq static ; then
243 myconf="${myconf} --without-raid"
244 ewarn "disabling raid support, has problem with static"
245 else
246 myconf="${myconf} --with-raid"
247 fi
248
249 if ! mysql_version_is_at_least "5.00.00.00" ; then
250 if mysql_version_is_at_least "4.01.00.00" ; then
251 myconf="${myconf} --with-charset=utf8"
252 myconf="${myconf} --with-collation=utf8_general_ci"
253 else
254 myconf="${myconf} --with-charset=latin1"
255 myconf="${myconf} --with-collation=latin1_swedish_ci"
256 fi 576 fi
257 fi 577 fi
258 578
259 # optional again from 2005-12-05
260 if mysql_version_is_at_least "5.01.00.00" ; then
261 myconf="${myconf} $(use_with innodb)"
262 else
263 myconf="${myconf} --with-innodb"
264 fi
265
266 # lots of chars
267 myconf="${myconf} --with-extra-charsets=all"
268
269 #The following fix is due to a bug with bdb on sparc's. See:
270 #http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
271 # it comes down to non-64-bit safety problems
272 if useq sparc || useq alpha || useq hppa || useq mips || useq amd64 \
273 || mysql_check_version_range "5.01.00.00 to 5.01.06.99"
274 then
275 ewarn "bdb berkeley-db disabled due to arch or version"
276 myconf="${myconf} --without-berkeley-db"
277 else
278 useq berkdb \
279 && myconf="${myconf} --with-berkeley-db=./bdb" \
280 || myconf="${myconf} --without-berkeley-db"
281 fi
282
283 if mysql_version_is_at_least "4.01.03.00" ; then
284 #myconf="${myconf} $(use_with geometry)"
285 myconf="${myconf} --with-geometry"
286 myconf="${myconf} $(use_with cluster ndbcluster)"
287 fi
288
289 mysql_version_is_at_least "4.01.11.00" && myconf="${myconf} `use_with big-tables`"
290 else
291 for i in ${minimal_exclude_list}; do
292 myconf="${myconf} --without-${i}"
293 done
294 myconf="${myconf} --without-berkeley-db"
295 myconf="${myconf} --with-extra-charsets=none"
296 fi
297
298 if mysql_version_is_at_least "4.01.03.00" && useq extraengine; then
299 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
300 myconf="${myconf} --with-archive-storage-engine"
301 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
302
303 mysql_version_is_at_least "4.01.04.00" \
304 && myconf="${myconf} --with-csv-storage-engine"
305
306 mysql_version_is_at_least "4.01.11.00" \
307 && myconf="${myconf} --with-blackhole-storage-engine"
308
309 # http://dev.mysql.com/doc/mysql/en/federated-description.html
310 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
311 if mysql_version_is_at_least "5.00.03.00" ; then
312 einfo "before to use federated engine be sure to read"
313 einfo "http://dev.mysql.com/doc/refman/5.0/en/federated-limitations.html"
314 myconf="${myconf} --with-federated-storage-engine"
315
316 # http://dev.mysql.com/doc/refman/5.1/en/partitioning-overview.html
317 if mysql_version_is_at_least "5.01.00.00" ; then
318 myconf="${myconf} --with-partition"
319 fi
320 fi
321
322 fi
323
324 mysql_version_is_at_least "5.00.18.00" \
325 && useq "max-idx-128" \
326 && myconf="${myconf} --with-max-indexes=128"
327
328 if mysql_version_is_at_least "5.01.05.00" ; then
329 myconf="${myconf} --with-row-based-replication"
330 fi
331
332 #Bug #114895,Bug #110149 579 # Bug #114895, bug #110149
333 filter-flags "-O" "-O[01]" 580 filter-flags "-O" "-O[01]"
581
334 #glibc-2.3.2_pre fix; bug #16496 582 # glib-2.3.2_pre fix, bug #16496
335 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 583 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
336 584
337 #the compiler flags are as per their "official" spec ;) 585 # As discovered by bug #246652, doing a double-level of SSP causes NDB to
338 #CFLAGS="${CFLAGS/-O?/} -O3" \ 586 # fail badly during cluster startup.
587 if [[ $(gcc-major-version) -lt 4 ]]; then
588 filter-flags "-fstack-protector-all"
589 fi
590
591 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
339 export CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-exceptions -fno-rtti" 592 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
340 mysql_version_is_at_least "5.00.00.00" \ 593 mysql_version_is_at_least "5.0" \
341 && export CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 594 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
595 export CXXFLAGS
342 596
343 econf \ 597 econf \
344 --program-suffix="${MY_SUFFIX}" \
345 --libexecdir="/usr/sbin" \ 598 --libexecdir="/usr/sbin" \
346 --sysconfdir="${MY_SYSCONFDIR}" \ 599 --sysconfdir="${MY_SYSCONFDIR}" \
347 --localstatedir="${MY_LOCALSTATEDIR}" \ 600 --localstatedir="${MY_LOCALSTATEDIR}" \
348 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 601 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
349 --libdir="${MY_LIBDIR}" \ 602 --libdir="${MY_LIBDIR}" \
350 --includedir="${MY_INCLUDEDIR}" \ 603 --includedir="${MY_INCLUDEDIR}" \
351 --with-low-memory \ 604 --with-low-memory \
352 --enable-assembler \
353 --enable-local-infile \
354 --with-mysqld-user=mysql \
355 --with-client-ldflags=-lstdc++ \ 605 --with-client-ldflags=-lstdc++ \
356 --enable-thread-safe-client \ 606 --enable-thread-safe-client \
357 --with-comment="Gentoo Linux ${PF}" \ 607 --with-comment="Gentoo Linux ${PF}" \
358 --with-unix-socket-path="/var/run/mysqld/mysqld${MY_SUFFIX}.sock" \
359 --with-zlib-dir=/usr \
360 --with-lib-ccflags="-fPIC" \
361 --without-readline \
362 --without-docs \ 608 --without-docs \
363 ${myconf} || die "bad ./configure" 609 ${myconf} || die "econf failed"
364 610
365 # TODO Move this before autoreconf !!! 611 # TODO: Move this before autoreconf !!!
366 find . -name 'Makefile' \ 612 find . -type f -name Makefile -print0 \
367 -exec sed --in-place \ 613 | xargs -0 -n100 sed -i \
368 -e 's|^pkglibdir\s*=\s*$(libdir)/mysql|pkglibdir = $(libdir)|' \ 614 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
369 -e 's|^pkgincludedir\s*=\s*$(includedir)/mysql|pkgincludedir = $(includedir)|' \
370 {} \;
371 615
372 emake || die "compile problem" 616 emake || die "emake failed"
617
618 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
373} 619}
374 620
375mysql_src_install() { 621mysql_src_install() {
376 622 # Make sure the vars are correctly initialized
377 mysql_init_vars 623 mysql_init_vars
624
378 make install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 625 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
379 626
380 insinto "${MY_INCLUDEDIR}" 627 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
381 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
382 628
383 # convenience links 629 # Convenience links
630 einfo "Making Convenience links for mysqlcheck multi-call binary"
384 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 631 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
385 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 632 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
386 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 633 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
387 634
388 # various junk (my-*.cnf moved elsewhere) 635 # Various junk (my-*.cnf moved elsewhere)
636 einfo "Removing duplicate /usr/share/mysql files"
389 rm -rf "${D}/usr/share/info" 637 rm -Rf "${D}/usr/share/info"
390 for removeme in "mysql-log-rotate" mysql.server* \ 638 for removeme in "mysql-log-rotate" mysql.server* \
391 binary-configure* my-*.cnf mi_test_all* 639 binary-configure* my-*.cnf mi_test_all*
392 do 640 do
393 rm -f ${D}/usr/share/mysql/${removeme} 641 rm -f "${D}"/usr/share/mysql/${removeme}
394 done 642 done
395 643
396 # TODO change at Makefile-am level
397 for moveme in "mysql_fix_privilege_tables.sql" \
398 "fill_help_tables.sql" "ndb-config-2-node.ini"
399 do
400 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
401 done
402
403 if [[ -n "${MY_SUFFIX}" ]] ; then
404 local notcatched=$(ls "${D}/usr/share/mysql"/*)
405 if [[ -n "${notcatched}" ]] ; then
406 ewarn "QA notice"
407 ewarn "${notcatched} files in /usr/share/mysql"
408 ewarn "bug mysql-herd to manage them"
409 fi
410 rm -rf "${D}/usr/share/mysql"
411 fi
412
413 # clean up stuff for a minimal build 644 # Clean up stuff for a minimal build
414 # this is anything server-specific
415 if useq minimal; then 645 if use minimal ; then
646 einfo "Remove all extra content for minimal build"
416 rm -rf ${D}${MY_SHAREDSTATEDIR}/{mysql-test,sql-bench} 647 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
417 rm -f ${D}/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 648 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
418 rm -f "${D}/usr/sbin/mysqld${MY_SUFFIX}" 649 rm -f "${D}/usr/sbin/mysqld"
419 rm -f ${D}${MY_LIBDIR}/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 650 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
420 fi 651 fi
421 652
422 # config stuff 653 # Configuration stuff
654 if mysql_version_is_at_least "4.1" ; then
655 mysql_mycnf_version="4.1"
656 else
657 mysql_mycnf_version="4.0"
658 fi
659 einfo "Building default my.cnf"
423 insinto "${MY_SYSCONFDIR}" 660 insinto "${MY_SYSCONFDIR}"
424 doins scripts/mysqlaccess.conf 661 doins scripts/mysqlaccess.conf
425 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
426 -e "s!@DATADIR@!${DATADIR}!g" \ 662 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
427 "${FILESDIR}/my.cnf-4.1-r1" \ 663 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
428 > "${TMPDIR}/my.cnf.ok" 664 > "${TMPDIR}/my.cnf.ok"
665 if mysql_version_is_at_least "4.1" && use latin1 ; then
666 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
667 fi
429 newins "${TMPDIR}/my.cnf.ok" my.cnf 668 newins "${TMPDIR}/my.cnf.ok" my.cnf
430 669
431 insinto "/etc/conf.d"
432 newins "${FILESDIR}/mysql-slot.conf.d-r1" "mysql"
433 mysql_version_is_at_least "5.00.11.00" \
434 && newins "${FILESDIR}/mysqlmanager-slot.conf.d" "mysqlmanager"
435
436 # minimal builds don't have the server 670 # Minimal builds don't have the MySQL server
437 if ! useq minimal; then 671 if ! use minimal ; then
438 exeinto /etc/init.d 672 einfo "Creating initial directories"
439 newexe "${FILESDIR}/mysql-slot.rc6-r3" "mysql" 673 # Empty directories ...
440
441 mysql_version_is_at_least "5.00.11.00" \
442 && newexe "${FILESDIR}/mysqlmanager-slot.rc6" "mysqlmanager"
443 insinto /etc/logrotate.d
444 sed -e "s!___MY_SUFFIX___!${MY_SUFFIX}!g" \
445 "${FILESDIR}/logrotate-slot.mysql" \
446 > "${TMPDIR}/logrotate.mysql"
447 newins "${TMPDIR}/logrotate.mysql" "mysql${MY_SUFFIX}"
448
449 #empty dirs...
450 diropts "-m0750" 674 diropts "-m0750"
451 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 675 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
452 dodir "${DATADIR}" 676 dodir "${MY_DATADIR}"
453 keepdir "${DATADIR}" 677 keepdir "${MY_DATADIR}"
454 chown -R mysql:mysql "${D}/${DATADIR}" 678 chown -R mysql:mysql "${D}/${MY_DATADIR}"
455 fi 679 fi
456 680
457 diropts "-m0755" 681 diropts "-m0755"
458 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 682 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
459 dodir "${folder}" 683 dodir "${folder}"
460 keepdir "${folder}" 684 keepdir "${folder}"
461 chown -R mysql:mysql "${D}/${folder}" 685 chown -R mysql:mysql "${D}/${folder}"
462 done 686 done
463 fi 687 fi
464 688
465 # docs 689 # Docs
690 einfo "Installing docs"
466 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 691 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
692 doinfo "${S}"/Docs/mysql.info
693
467 # minimal builds don't have the server 694 # Minimal builds don't have the MySQL server
468 if ! useq minimal; then 695 if ! use minimal ; then
696 einfo "Including support files and sample configurations"
697 docinto "support-files"
698 for script in \
699 "${S}"/support-files/my-*.cnf \
700 "${S}"/support-files/magic \
701 "${S}"/support-files/ndb-config-2-node.ini
702 do
703 dodoc "${script}"
704 done
705
706 docinto "scripts"
707 for script in "${S}"/scripts/mysql* ; do
708 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
709 done
710
711 fi
712
713 mysql_lib_symlinks "${D}"
714}
715
716mysql_pkg_preinst() {
717 enewgroup mysql 60 || die "problem adding 'mysql' group"
718 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
719}
720
721mysql_pkg_postinst() {
722 # Make sure the vars are correctly initialized
723 mysql_init_vars
724
725 # Check FEATURES="collision-protect" before removing this
726 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
727
728 # Secure the logfiles
729 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
730 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
731 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
732
733 # Minimal builds don't have the MySQL server
734 if ! use minimal ; then
469 docinto "support-files" 735 docinto "support-files"
470 for script in \ 736 for script in \
471 support-files/my-*.cnf \ 737 support-files/my-*.cnf \
472 support-files/magic \ 738 support-files/magic \
473 support-files/ndb-config-2-node.ini 739 support-files/ndb-config-2-node.ini
477 743
478 docinto "scripts" 744 docinto "scripts"
479 for script in scripts/mysql* ; do 745 for script in scripts/mysql* ; do
480 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 746 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
481 done 747 done
482 fi
483 748
484 # oops, temporary fix 749 einfo
485 mysql_check_version_range "5.00.16.00 to 5.00.18.99" \ 750 elog "You might want to run:"
486 && cp -f \ 751 elog "\"emerge --config =${CATEGORY}/${PF}\""
487 "${WORKDIR}/mysql-extras/fill_help_tables.sql-5.0" \ 752 elog "if this is a new install."
488 "${D}/usr/share/mysql${MY_SUFFIX}/fill_help_tables.sql" 753 einfo
489} 754 fi
490 755
491mysql_pkg_preinst() { 756 if mysql_version_is_at_least "5.1.12" && use pbxt ; then
757 # TODO: explain it better
758 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
759 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
760 elog "if, after that, you cannot start the MySQL server,"
761 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
762 elog "use the MySQL upgrade script to restore the table"
763 elog "or execute the following SQL command:"
764 elog " CREATE TABLE IF NOT EXISTS plugin ("
765 elog " name char(64) binary DEFAULT '' NOT NULL,"
766 elog " dl char(128) DEFAULT '' NOT NULL,"
767 elog " PRIMARY KEY (name)"
768 elog " ) CHARACTER SET utf8 COLLATE utf8_bin;"
769 fi
492 770
493 # create a list of files, to be used 771 mysql_check_version_range "4.0 to 5.0.99.99" \
494 # by external utilities 772 && use berkdb \
495 # will be used in pkg_postinst 773 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
496 local filelist="${TMPDIR}/FILELIST"
497 pushd "${D}/" &>/dev/null
498 mkdir -p "${ROOT}/var/lib/eselect/mysql/"
499 env -i find usr/bin/ usr/sbin/ usr/share/man \
500 -type f -name "*${MY_SUFFIX}*" \
501 -and -not -name "mysql_config${MY_SUFFIX}" \
502 > "${filelist}"
503 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
504 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
505 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
506 popd &>/dev/null
507
508 enewgroup mysql 60 || die "problem adding group mysql"
509 enewuser mysql 60 -1 /dev/null mysql \
510 || die "problem adding user mysql"
511} 774}
512 775
513mysql_pkg_postinst() { 776mysql_pkg_config() {
777 local old_MY_DATADIR="${MY_DATADIR}"
514 778
779 # Make sure the vars are correctly initialized
515 mysql_init_vars 780 mysql_init_vars
516 mysql_lib_symlinks
517 781
518 # mind at FEATURES=collision-protect before to remove this 782 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
519 [ -d "${ROOT}/var/log/mysql" ] \
520 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
521 783
522 #secure the logfiles... does this bother anybody? 784 if built_with_use ${CATEGORY}/${PN} minimal ; then
523 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 785 die "Minimal builds do NOT include the MySQL server"
524 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 786 fi
525 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
526 787
527 # list of files, to be used 788 if [[ ( -n "${MY_DATADIR}" ) && ( "${MY_DATADIR}" != "${old_MY_DATADIR}" ) ]]; then
528 # by external utilities 789 local MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${MY_DATADIR})"
529 mkdir -p "${ROOT}/var/lib/eselect/mysql/" 790 local old_MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${old_MY_DATADIR})"
530 cp "${TMPDIR}/FILELIST" "${ROOT}/var/lib/eselect/mysql/mysql${MY_SUFFIX}"
531 791
532 if ! useq minimal; then 792 if [[ -d "${old_MY_DATADIR_s}" ]]; then
533 if [[ ${SLOT} -gt 0 ]] ; then 793 if [[ -d "${MY_DATADIR_s}" ]]; then
534 if [[ -f "${ROOT}/usr/sbin/mysqld" ]] ; then 794 ewarn "Both ${old_MY_DATADIR_s} and ${MY_DATADIR_s} exist"
535 einfo "you may want to read:" 795 ewarn "Attempting to use ${MY_DATADIR_s} and preserving ${old_MY_DATADIR_s}"
536 einfo "http://www.gentoo.org/doc/en/mysql-upgrade-slotted.xml"
537 else 796 else
538 local tmpres="$( eselect mysql show )" 797 elog "Moving MY_DATADIR from ${old_MY_DATADIR_s} to ${MY_DATADIR_s}"
539 # "like grep -q unset" 798 mv --strip-trailing-slashes -T "${old_MY_DATADIR_s}" "${MY_DATADIR_s}" \
540 if [[ "{$tmpres}" == "{$tmpres/unset/}" ]] ; then 799 || die "Moving MY_DATADIR failed"
541 eselect mysql set 1
542 else
543 einfo "The version of mysql emerged now stils is _NOT_ the default"
544 einfo "you may want to run \"eselect myqsl list\" followed by a "
545 einfo "\"eselect myqsl set 1\" to chose the default mysql server"
546 fi
547 fi 800 fi
548 fi 801 else
549 802 ewarn "Previous MY_DATADIR (${old_MY_DATADIR_s}) does not exist"
550 # your friendly public service announcement... 803 if [[ -d "${MY_DATADIR_s}" ]]; then
551 einfo 804 ewarn "Attempting to use ${MY_DATADIR_s}"
552 einfo "You might want to run:" 805 else
553 einfo "\"emerge --config =${CATEGORY}/${PF}\"" 806 eerror "New MY_DATADIR (${MY_DATADIR_s}) does not exist"
554 einfo "if this is a new install." 807 die "Configuration Failed! Please reinstall ${CATEGORY}/${PN}"
555 einfo 808 fi
556 einfo "InnoDB is not optional as of MySQL-4.0.24, at the request of upstream."
557 fi 809 fi
558}
559
560mysql_pkg_config() {
561 mysql_init_vars
562 [[ -z "${DATADIR}" ]] && die "sorry, unable to find DATADIR"
563
564 if built_with_use dev-db/mysql minimal; then
565 die "Minimal builds do NOT include the MySQL server"
566 fi 810 fi
567 811
568 local pwd1="a" 812 local pwd1="a"
569 local pwd2="b" 813 local pwd2="b"
570 local maxtry=5 814 local maxtry=5
571 815
572 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 816 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
573 ewarn "You have already a MySQL database in place." 817 ewarn "You have already a MySQL database in place."
574 ewarn "(${ROOT}/${DATADIR}/*)" 818 ewarn "(${ROOT}/${MY_DATADIR}/*)"
575 ewarn "Please rename or delete it if you wish to replace it." 819 ewarn "Please rename or delete it if you wish to replace it."
576 die "MySQL database already exists!" 820 die "MySQL database already exists!"
577 fi 821 fi
578 822
823 # Bug #213475 - MySQL _will_ object strenously if your machine is named
824 # localhost. Also causes weird failures.
825 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
826
579 einfo "Creating the mysql database and setting proper" 827 einfo "Creating the mysql database and setting proper"
580 einfo "permissions on it..." 828 einfo "permissions on it ..."
581 829
582 einfo "Insert a password for the mysql 'root' user" 830 einfo "Insert a password for the mysql 'root' user"
583 ewarn "Avoid [\"'\\_%] characters in the password" 831 ewarn "Avoid [\"'\\_%] characters in the password"
584
585 read -rsp " >" pwd1 ; echo 832 read -rsp " >" pwd1 ; echo
833
586 einfo "Check the password" 834 einfo "Retype the password"
587 read -rsp " >" pwd2 ; echo 835 read -rsp " >" pwd2 ; echo
588 836
589 if [[ "x$pwd1" != "x$pwd2" ]] ; then 837 if [[ "x$pwd1" != "x$pwd2" ]] ; then
590 die "Passwords are not the same" 838 die "Passwords are not the same"
591 fi 839 fi
592 840
593 local options="" 841 local options=""
594 local sqltmp="$(emktemp)" 842 local sqltmp="$(emktemp)"
595 843
596 local help_tables="${MY_SHAREDSTATEDIR}/fill_help_tables.sql" 844 local help_tables="${ROOT}${MY_SHAREDSTATEDIR}/fill_help_tables.sql"
597 [[ -r "${help_tables}" ]] \ 845 [[ -r "${help_tables}" ]] \
598 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 846 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
599 || touch "${TMPDIR}/fill_help_tables.sql" 847 || touch "${TMPDIR}/fill_help_tables.sql"
600 help_tables="${TMPDIR}/fill_help_tables.sql" 848 help_tables="${TMPDIR}/fill_help_tables.sql"
601 849
602 pushd "${TMPDIR}" &>/dev/null 850 pushd "${TMPDIR}" &>/dev/null
603 ${ROOT}/usr/bin/mysql_install_db${MY_SUFFIX} | grep -B5 -A999 -i "ERROR" 851 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
852 if [ $? -ne 0 ]; then
853 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
854 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
855 fi
604 popd &>/dev/null 856 popd &>/dev/null
605 [[ -f ${ROOT}/${DATADIR}/mysql/user.frm ]] || die "MySQL databases not installed" 857 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
858 || die "MySQL databases not installed"
606 chown -R mysql:mysql ${ROOT}/${DATADIR} 2> /dev/null 859 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
607 chmod 0750 ${ROOT}/${DATADIR} 2> /dev/null 860 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
608 861
609 if mysql_version_is_at_least "4.01.03.00" ; then 862 if mysql_version_is_at_least "4.1.3" ; then
610 options="--skip-ndbcluster" 863 options="--skip-ndbcluster"
611 864
612 # Filling timezones, see 865 # Filling timezones, see
613 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 866 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
614 ${ROOT}/usr/bin/mysql_tzinfo_to_sql${MY_SUFFIX} ${ROOT}/usr/share/zoneinfo \ 867 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
615 > "${sqltmp}" 2>/dev/null
616 868
617 if [[ -r "${help_tables}" ]] ; then 869 if [[ -r "${help_tables}" ]] ; then
618 cat "${help_tables}" >> "${sqltmp}" 870 cat "${help_tables}" >> "${sqltmp}"
619 fi 871 fi
620 fi 872 fi
621 873
622 local socket=${ROOT}/var/run/mysqld/mysqld${MY_SUFFIX}${RANDOM}.sock 874 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
623 local pidfile=${ROOT}/var/run/mysqld/mysqld${MY_SUFFIX}${RANDOM}.sock 875 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
624 local mysqld="${ROOT}/usr/sbin/mysqld${MY_SUFFIX} \ 876 local mysqld="${ROOT}/usr/sbin/mysqld \
625 ${options} \ 877 ${options} \
626 --user=mysql \ 878 --user=mysql \
627 --skip-grant-tables \ 879 --skip-grant-tables \
628 --basedir=${ROOT}/usr \ 880 --basedir=${ROOT}/usr \
629 --datadir=${ROOT}/${DATADIR} \ 881 --datadir=${ROOT}/${MY_DATADIR} \
630 --skip-innodb \ 882 --skip-innodb \
631 --skip-bdb \ 883 --skip-bdb \
632 --skip-networking \ 884 --skip-networking \
633 --max_allowed_packet=8M \ 885 --max_allowed_packet=8M \
634 --net_buffer_length=16K \ 886 --net_buffer_length=16K \
635 --socket=${socket} \ 887 --socket=${socket} \
636 --pid-file=${pidfile}" 888 --pid-file=${pidfile}"
637 $mysqld & 889 ${mysqld} &
638 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 890 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
639 maxtry=$(($maxtry-1)) 891 maxtry=$((${maxtry}-1))
640 echo -n "." 892 echo -n "."
641 sleep 1 893 sleep 1
642 done 894 done
643 895
644 # do this from memory we don't want clear text password in temp files 896 # Do this from memory, as we don't want clear text passwords in temp files
645 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 897 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'"
646 ${ROOT}/usr/bin/mysql${MY_SUFFIX} \ 898 "${ROOT}/usr/bin/mysql" \
647 --socket=${socket} \ 899 --socket=${socket} \
648 -hlocalhost \ 900 -hlocalhost \
649 -e "${sql}" 901 -e "${sql}"
650 902
651 einfo "Loading \"zoneinfo\" this step may require few seconds" 903 einfo "Loading \"zoneinfo\", this step may require a few seconds ..."
652 904
653 ${ROOT}/usr/bin/mysql${MY_SUFFIX} \ 905 "${ROOT}/usr/bin/mysql" \
654 --socket=${socket} \ 906 --socket=${socket} \
655 -hlocalhost \ 907 -hlocalhost \
656 -uroot \ 908 -uroot \
657 -p"${pwd1}" \ 909 -p"${pwd1}" \
658 mysql < "${sqltmp}" 910 mysql < "${sqltmp}"
659 911
660 # server stop and cleanup 912 # Stop the server and cleanup
661 kill $(< "${pidfile}" ) 913 kill $(< "${pidfile}" )
662 rm "${sqltmp}" 914 rm -f "${sqltmp}"
663 einfo "stopping the server," 915 einfo "Stopping the server ..."
664 wait %1 916 wait %1
665 einfo "done" 917 einfo "Done"
666} 918}
667 919
668mysql_pkg_postrm() { 920mysql_pkg_postrm() {
669 mysql_lib_symlinks 921 : # mysql_lib_symlinks "${D}"
670 if [[ ${SLOT} -gt 0 ]] ; then
671 einfo "you may want to run \"eselect myqsl list\" followed by a "
672 einfo "\"eselect myqsl list\" to chose the default mysql server"
673 fi
674} 922}

Legend:
Removed from v.1.12  
changed lines
  Added in v.1.111

  ViewVC Help
Powered by ViewVC 1.1.20